//----------------------------------------------------------------------------
//  Project Sample
//  Some Company
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    Sample Application
//  FILE:         sampleapp.cpp
//  AUTHOR:       Author
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TSampleAppl (TApplication).
//  (Generated by OWL 6.0 Wizard for MS VC )
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <stdio.h>

#include "Sampleapp.h"
#include "Samplecl.h" // Definition of client class.

#include "myclass.h"

//{{TSampleAppl Implementation}}

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TSampleAppl, TApplication)
//{{TSampleApplRSP_TBL_BEGIN}}
  EV_COMMAND(CM_FILENEW, CmFileNew),
  EV_COMMAND(CM_FILEOPEN, CmFileOpen),
//{{TSampleApplRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TSampleAppl
//

TSampleAppl::TSampleAppl() : TApplication(_T("Sample"))
{

  // Common file file flags and filters for Open/Save As dialogs.  Filename and directory are
  // computed in the member functions CmFileOpen, and CmFileSaveAs.
  //
  FileData.Flags |= OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
  FileData.SetFilter(_T("All Files (*.*)|*.*|"));
  FileData.DefExt = _T("txt");
  // INSERT>> Your constructor code here.
}


TSampleAppl::~TSampleAppl()
{
  // INSERT>> Your destructor code here.
}




//--------------------------------------------------------
// TSampleAppl
// ~~~~~
// Application intialization.
//
void TSampleAppl::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIFrameWindow* frame = new TSDIFrameWindow(0, GetName(), 0);


  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  // Associate with the accelerator table.
  //
  frame->Attr.AccelTable = IDM_SDI;

  SetMainWindow(frame);

  // Menu associated with window.
  //
  frame->SetMenuDescr(TMenuDescr(IDM_SDI));
}

//--------------------------------------------------------
// TSampleAppl
// ~~~~~~~~~~~
// Menu File New command
//
void TSampleAppl::CmFileNew()
{
//******************************************************************************************
  // THIS WORKS JUST FINE
  ofpstream os("c:\\sampletest.sav");
  MyClass *pMyClass = new MyClass;

  os << pMyClass;

  delete pMyClass;

//******************************************************************************************
}


//------------------------------------------------------------------------------
// TSampleAppl
// ~~~~~~~~~~~
// Menu File Open command
//
void TSampleAppl::CmFileOpen()
{
  // Display standard Open dialog box to select a file name.
  //
  *FileData.FileName = 0;

  TSampleWindow* client = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(),
                             TSampleWindow);     // Client window for the frame.
  if (client->CanClose())
    if (TFileOpenDialog(GetMainWindow(), FileData).Execute() == IDOK)
      OpenFile();
}

void TSampleAppl::OpenFile(LPCTSTR fileName)
{
  if (fileName)
    _tcscpy(FileData.FileName, fileName);

//******************************************************************************************

  // here is where the compiler will always generate an error, but this SHOULD work!!
  MyClass *pMyClass;
  ifpstream is(FileData.FileName);

  is >> pMyClass;

//******************************************************************************************
}



//{{TSDIFrameWindow Implementation}}


TSDIFrameWindow::TSDIFrameWindow(TWindow* parent, LPCTSTR title, TWindow* clientWnd, bool shrinkToClient, TModule* module)
:
  TFrameWindow(parent, title, !clientWnd ? new TSampleWindow(0,_T("")) : clientWnd, shrinkToClient, module)
{
  // INSERT>> Your constructor code here.

}


TSDIFrameWindow::~TSDIFrameWindow()
{
  // INSERT>> Your destructor code here.

}





//-------------------------------------------------------------------
// OwlMain
// ~~~~~~~
// Application Start here.
//
int OwlMain(int , LPTSTR [])
{

  return TSampleAppl().Run();
}

